/*************************************************************************
    inits.h

    03/02/08	Xiaohong
*************************************************************************/
#ifndef _INCLUDE_INITS_H________________________________________
#define _INCLUDE_INITS_H________________________________________

#include "timecode.h"
#include "buffer.h"

#define MAX_SECTOR_SIZE		4096		/* Max Sektor Groesse	*/

typedef struct video_struc	/* Informationen ueber Video Stream	*/
{   unsigned int stream_length  ;
    unsigned int num_sequence 	;
    unsigned int num_seq_end	;
    unsigned int num_pictures 	;
    unsigned int num_groups 	;
    unsigned int num_frames[4] 	;
    unsigned int avg_frames[4]  ;
    
    unsigned int horizontal_size;
    unsigned int vertical_size 	;
    unsigned int aspect_ratio	;
    unsigned int picture_rate	;
    unsigned int bit_rate 	;
    unsigned int comp_bit_rate	;
    unsigned int vbv_buffer_size;
    unsigned int CSPF;
}Video_struc; 		

typedef struct audio_struc	/* Informationen ueber Audio Stream	*/
{   unsigned int stream_length  ;
    unsigned int num_syncword	;
    unsigned int num_frames [2]	;
    unsigned int size_frames[2] ;
    unsigned int layer		;
    unsigned int protection	;
    unsigned int bit_rate	;
    unsigned int frequency	;
    unsigned int mode		;
    unsigned int mode_extension ;
    unsigned int copyright      ;
    unsigned int original_copy  ;
    unsigned int emphasis	;
}Audio_struc;

class Vaunit_struc	/* Informationen ueber Video AU's 	*/
{
public:
	Vaunit_struc();
	void empty(void);
	void write_file(HANDLE);
	bool read_file(HANDLE);

	unsigned int length;
    unsigned int type;
    Timecode_struc DTS;
    Timecode_struc PTS;
};

class Aaunit_struc	/* Informationen ueber Audio AU's 	*/
{
public:
	Aaunit_struc();
	void empty(void);
	void write_file(HANDLE);
	bool read_file(HANDLE);

	unsigned long length;
    Timecode_struc PTS;
};

typedef struct sector_struc	/* Ein Sektor, kann Pack, Sys Header	*/
				/* und Packet enthalten.		*/
{   unsigned char  buf [MAX_SECTOR_SIZE] ;
    unsigned int   length_of_sector  ;
    unsigned int   length_of_packet_data ;
    Timecode_struc TS                ;
} Sector_struc;

void empty_video_struc (Video_struc*);
void empty_audio_struc (Audio_struc*);
void empty_sector_struc(Sector_struc*);
void init_buffer_struc(Buffer_struc*,unsigned int);

#endif
