/*************************************************************************
    sequencedata.h

    03/02/08	Xiaohong
*************************************************************************/
#ifndef _INCLUDE_SEQUENCEDATA_H____________________________________________
#define _INCLUDE_SEQUENCEDATA_H____________________________________________
#include "picturestruct.h"
#include "systemdata.h"
/**********************************************************
	SEQUENCEDATA ̐錾
**********************************************************/
typedef struct
{
	int nHFrameSize,nVFrameSize;
	int nWidth,nHeight;
	int nChromWidth,nChromHeight,nBlockCount;
	int nMacroBlocksWidth,nMacroBlocksHeight;
	int nWidth2,nHeight2,nMacroBlocksHeight2,nChromWidth2;
	int nAspectRatio;
	int nFrameRateCode;
	double fFrameRate;
	double fBitRate;
	int nVBVBufferSize;
	unsigned char uConstrainedParams;
	bool bLoadIQuant,bLoadNIQuant;
}SEQUENCEHEADER;

typedef struct
{
	int nProfile,nLevel;
	bool bProgressSequence;
	int nChromaFormat;
	bool bLowDelay;
}SEQUENCEEXTENSION;

typedef struct
{
	int nVideoFormat;
	int nColorPrimaries;
	int nTransferCharacteristics;
	int nMatrixCoefficients;
	int nDisplayHSize;
	int nDisplayVSize;
}SEQUENCEDISPLAYEXTENSION;

class SEQUENCEDATA
{
public:
	void PutSequenceHeader(SYSTEMDATA*,const PICTURESTRUCT*);
	void PutSequenceDisplayExtension(SYSTEMDATA*);
	void PutSequenceEndCode(SYSTEMDATA*);

	SEQUENCEHEADER stHeader;
	SEQUENCEEXTENSION stExtension;
	SEQUENCEDISPLAYEXTENSION stDisplayExtension;
};
#endif